-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------
function Citadel:StartActivity()
   	print("START! -- Citadel:StartActivity()!");
   	-- Set up teams
   	-- Team 2 is always CPU
   	self.CPUTeam = Activity.TEAM_2;
	self.PlayerTeam = Activity.TEAM_1;
	self.RogueTeam = -1;
	
	self.WindZone = SceneMan.Scene:GetArea("Wind");

	self.braindead = {};
	self.AssignedBrains = {};
	self.MOIDLimit = 190;
	self.UltimateMOIDLimit = 215;
    
    self.GenericTimer = Timer();
    self.GenericTimer:Reset();
	
    self.WindTimer = Timer();
    self.WindTimer:Reset();
	
    self.FightPhase = { SNEAKIN = 1 , TOTALALERT = 2 , ESCAPE = 3 };
    self.CurrentFightPhase = self.FightPhase.SNEAKIN;

	-- Everything about alerts here
    self.AlertCheckTimer = Timer();
    self.AlertCheckTimer:Reset();
	self.AlertCheckInterval = 250;
	self.AlertStopTimer = Timer();
	self.AlertStopTimer:Reset();
	self.AlertStopInterval = 15000; -- Time after which alert will end
	self.AlertDistance = 550; -- Distance to spot ronins for alert
	self.BaseOnAlert = false;
	self.Spotted = false;
	self.AlertSoruce = nil;
	self.EnumEven = false;
	
	self.CurrentAlertedActors = {};
	self.OldAlertedActors = {};

	self.AlertStrings = {};
	self.AlertStrings[1] = "A";
	self.AlertStrings[2] = "A";
	self.AlertStrings[3] = "AL";
	self.AlertStrings[4] = "AL";
	self.AlertStrings[5] = "ALE";
	self.AlertStrings[6] = "ALE";
	self.AlertStrings[7] = "ALER";
	self.AlertStrings[8] = "ALER";
	self.AlertStrings[9] = "ALERT";
	self.AlertStrings[10] = "ALERT";
	self.AlertStrings[11] = "ALERT!";
	self.AlertStrings[12] = "ALERT!";
	self.AlertStrings[13] = "ALERT!!";
	self.AlertStrings[14] = "ALERT!!";
	self.AlertStrings[15] = "ALERT!!!";
	self.AlertStrings[16] = "ALERT!!!";
	
	-- Alert screens
	self.ScreenCount = 10;

	self.ScreensPos = {};

	self.ScreensPos[1] = Vector(336, 732);
	self.ScreensPos[2] = Vector(648, 732);
	self.ScreensPos[3] = Vector(492, 924);
	self.ScreensPos[4] = Vector(492, 1128);
	self.ScreensPos[5] = Vector(492, 1680);
	self.ScreensPos[6] = Vector(348, 2268);
	self.ScreensPos[7] = Vector(636, 2268);
	self.ScreensPos[8] = Vector(492, 2724);
	self.ScreensPos[9] = Vector(240, 5172);
	self.ScreensPos[10] = Vector(744, 5172);
	
	self.Screens = {};

	for i = 1, self.ScreenCount do
		self.Screens[i] = CreateAEmitter("Citadel Secured Screen");
		self.Screens[i].Pos = self.ScreensPos[i];
		self.Screens[i]:EnableEmission(true);
		MovableMan:AddParticle(self.Screens[i]);
	end
	
	
	self.BigScreenA = CreateAEmitter("Citadel Big Screen 1");
	self.BigScreenA.Pos = Vector(384,5204);
	self.BigScreenA:EnableEmission(true);
	MovableMan:AddParticle(self.BigScreenA);

	self.BigScreenB = CreateAEmitter("Citadel Big Screen 2");
	self.BigScreenB.Pos = Vector(600,5204);
	self.BigScreenB:EnableEmission(true);
	MovableMan:AddParticle(self.BigScreenB);

	-- Clone generators
	self.CloningVatsDesyncTimer = Timer();
	self.CloningVatsDesyncTimer:Reset();
	self.CloningEnabled = false;	
	self.CloningVats = {};
	self.CloningVatsCoords = {};
	
	self.CloningVatsCoords[1] = Vector(492, 528);
	self.CloningVatsCoords[2] = Vector(336, 1280);
	self.CloningVatsCoords[3] = Vector(120, 1656);
	self.CloningVatsCoords[4] = Vector(864, 1656);
	self.CloningVatsCoords[5] = Vector(492, 2412);

   	for i = 1 , 5 do
		self.CloningVats[i] = CreateAEmitter("Clone Vat" , "Citadel.rte");
		self.CloningVats[i].Pos = self.CloningVatsCoords[i];
		self.CloningVats[i].Team = self.CPUTeam;
		self.CloningVats[i]:EnableEmission(false);
		MovableMan:AddParticle(self.CloningVats[i]);
	end

	--self.CloningVats[1].Pos = Vector(492, 100); -- debug only
	--self.CloningVats[2].Pos = Vector(336, 100); -- debug only

	
	-- Troops arming zones
	self.RearmTimer = Timer();
	self.RearmTimer:Reset();
	self.RearmInterval = 2000;
	self.LightWeapons = {"Pistol" , "Compact Assault Rifle" , "Shotgun"}
	self.ZombieWeapons = {"Blunderbuss"}
	self.RearmSt = {};
	
	self.RearmSt[1] = Box(Vector(492 - 18, 624 - 18) , 36 , 36);
	self.RearmSt[2] = Box(Vector(336 - 18, 1404 - 18) , 36 , 36);
	self.RearmSt[3] = Box(Vector(120 - 18, 1740 - 18) , 36 , 36);
	self.RearmSt[4] = Box(Vector(864 - 18, 1740 - 18) , 36 , 36);
	self.RearmSt[5] = Box(Vector(492 - 18, 2508 - 18) , 36 , 36);
	
	self.RearmStLastArm = {};
	for i = 1, #self.RearmSt do
		self.RearmStLastArm[i] = self.RearmTimer.ElapsedSimTimeMS;
	end
	
	-- Zones defining firing point checked for troops precence
	self.PatrolZones = {}; 
	self.PatrolZones[1] = SceneMan.Scene:GetArea("PatrolZone1");
	self.PatrolZones[2] = SceneMan.Scene:GetArea("PatrolZone2");
	self.PatrolZones[3] = SceneMan.Scene:GetArea("PatrolZone3");
	self.PatrolZones[4] = SceneMan.Scene:GetArea("PatrolZone4");
	self.PatrolZones[5] = SceneMan.Scene:GetArea("PatrolZone5");
	self.PatrolZones[6] = SceneMan.Scene:GetArea("PatrolZone6");
	self.PatrolZones[7] = SceneMan.Scene:GetArea("PatrolZone7");
	self.PatrolZones[8] = SceneMan.Scene:GetArea("PatrolZone8");
	self.PatrolZones[9] = SceneMan.Scene:GetArea("PatrolZone9");
	self.PatrolZones[10] = SceneMan.Scene:GetArea("PatrolZone10");
	self.PatrolZones[11] = SceneMan.Scene:GetArea("PatrolZone11");
	self.PatrolZones[12] = SceneMan.Scene:GetArea("PatrolZone12");
	self.PatrolZones[13] = SceneMan.Scene:GetArea("PatrolZone13");
	
	self.PatrolWaypoints = {};
	self.PatrolWaypoints[1] = {Vector(828 , 612), Vector(204 , 612)};
	self.PatrolWaypoints[2] = {Vector(144 , 696), Vector(756 , 816)};
	self.PatrolWaypoints[3] = {Vector(828 , 912), Vector(384 , 1044)};
	self.PatrolWaypoints[4] = {Vector(336 , 1116), Vector(588 , 1236)};
	self.PatrolWaypoints[5] = {Vector(96 , 1440), Vector(780 , 1440)};
	self.PatrolWaypoints[6] = {Vector(156 , 1764), Vector(864 , 1452)};
	self.PatrolWaypoints[7] = {Vector(864 , 1840), Vector(116 , 1840)};
	self.PatrolWaypoints[8] = {Vector(492 , 1956), Vector(492 , 2268)};
	self.PatrolWaypoints[9] = {Vector(156 , 2268), Vector(564 , 2556)};
	self.PatrolWaypoints[10] = {Vector(812 , 2268), Vector(408 , 2556)};
	self.PatrolWaypoints[11] = {Vector(228 , 2556), Vector(684 , 2736)};
	self.PatrolWaypoints[12] = {Vector(744 , 2556), Vector(288 , 2724)};
	self.PatrolWaypoints[13] = {Vector(288 , 2724), Vector(684 , 2724)};

    -- Wind setup
    self.Wind = {};
    self.WindCount = 35;
    for i = 0 , self.WindCount do
		self.Wind[i] = CreateAEmitter("Citadel Wind" , "Citadel.rte");
		self.Wind[i].Pos = self.WindZone:GetRandomPoint();
		self.Wind[i]:EnableEmission(true);
		MovableMan:AddParticle(self.Wind[i]);
    end
	
	-- No money and alive reinforcements availabe for player according to the plot
	self.PlayerGold = 0; -- Player starting credits
    
	-- Mission specific vars
	self.VatWarningShown = false;

	self.TerminalZone = SceneMan.Scene:GetArea("TerminalZone");
	
	-- Total alert phase
	self.ChunksComplete = 0;
	self.TotalChunks = 100;
	self.ChunkInterval = 350;
	
	-- Escape
	self.DropshipSpawnTimer = Timer();
	self.DropshipSpawnInterval = 25000;
	self.EvacDropship = nil;
	
   	-- Set up players
	self.Ronins = {};
	
    for player = 0, self.PlayerCount - 1 do
        -- Check if we already have a brain assigned
        if not self:GetPlayerBrain(player) then
			self.braindead[player] = false;
			local brain = CreateAHuman("Dafred Brain Citadel" , "Citadel.rte");
			
			-- brain.Pos = Vector(393, 5256); -- debug only

			
			brain.Pos = Vector(30 + player * 20, 420);
			brain.AIMode = Actor.AIMODE_SENTRY;
			brain.Team = self.PlayerTeam;
			brain:AddInventoryItem(CreateHDFirearm("Dart Gun" , "Citadel.rte"));
			if player == 0 then
				brain:AddInventoryItem(CreateHeldDevice("Virus Chip" , "Citadel.rte"));
			end
			self.AssignedBrains[player] = brain;
            -- Let the spawn into the world, passing ownership
            MovableMan:AddActor(brain);
			self.Ronins[#self.Ronins + 1] = brain;
            -- Set the found brain to be the selected actor at start
            self:SetPlayerBrain(brain, player);
            SceneMan:SetScroll(self:GetPlayerBrain(player).Pos, player);
            self:SetLandingZone(self:GetPlayerBrain(player).Pos, player);
            -- Set the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
            self:SetObservationTarget(self:GetPlayerBrain(player).Pos, player);
        end
    end

	self.RoninGrenades = { "Pineapple Grenade" };
	self.SpecialAbilitiesTimer = Timer();
	self.SpecialAbilitiesTimer:Reset();
	self.SpecialAbilitiesInterval = 150;
	
	-- Ronin squad
	--self.Mia = nil;
	self.Dimitry = nil;
	self.Gordon = nil;

	--[[self.Mia = CreateAHuman("Mia" , "Ronin.rte");
	self.Mia.Pos = Vector(180,420);
	self.Mia:AddInventoryItem(CreateHDFirearm("Dart Gun" , "Citadel.rte"));
	self.Mia:AddInventoryItem(CreateHDFirearm("Medikit" , "Citadel.rte"));]]--
	
	self.Dimitri = CreateAHuman("Dimitri" , "Ronin.rte");
	self.Dimitri.Pos = Vector(800,420);
	self.Dimitri:AddInventoryItem(CreateHDFirearm("Rifle Long" , "Ronin.rte"));
	self.Dimitri:AddInventoryItem(CreateHDFirearm("Dart Gun" , "Citadel.rte"));
	self.Dimitri:AddInventoryItem(CreateHDFirearm("Medikit" , "Citadel.rte"));
    
	self.Gordon = CreateAHuman("Gordon" , "Ronin.rte");
	self.Gordon.Pos = Vector(900,420);
	self.Gordon:AddInventoryItem(CreateHDFirearm("M1600" , "Ronin.rte"));
	
	--self.Mia.Team = self.PlayerTeam;
	self.Dimitri.Team = self.PlayerTeam;
	self.Gordon.Team = self.PlayerTeam;
	
    --MovableMan:AddActor(self.Mia);
    MovableMan:AddActor(self.Dimitri);
    MovableMan:AddActor(self.Gordon);


	-- self.Ronins[#self.Ronins + 1] = self.Mia;
	self.Ronins[#self.Ronins + 1] = self.Dimitri;
	self.Ronins[#self.Ronins + 1] = self.Gordon;

    
    -- Set up AI modes for the Actors that have been added to the scene by the scene definition
    for actor in MovableMan.AddedActors do
		actor.AIMode = Actor.AIMODE_SENTRY;
    end

    for actor in MovableMan.Actors do
		actor.AIMode = Actor.AIMODE_SENTRY;
    end

    -- Set the team's funds.
    self:SetTeamFunds(self.PlayerGold,self.PlayerTeam);
end
-----------------------------------------------------------------------------------------
-- Pause Activity
-----------------------------------------------------------------------------------------
function Citadel:PauseActivity(pause)
    print("PAUSE! -- Citadel:PauseActivity()!");
end

-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------
function Citadel:EndActivity()
    print("END! -- Citadel:EndActivity()!");
end
-----------------------------------------------------------------------------------------
-- Skip phases
-----------------------------------------------------------------------------------------
function Citadel:SkipPhases()
	if self.CurrentFightPhase == self.FightPhase.SNEAKIN then
		self:AdvanceToTotalAlert();
	elseif self.CurrentFightPhase == self.FightPhase.TOTALALERT then
		self:AdvanceToEscape();
	end
end
-----------------------------------------------------------------------------------------
-- Update Activity
-----------------------------------------------------------------------------------------
function Citadel:UpdateActivity()
   	-- Clear all objective markers, they get re-added each frame
   	self:ClearObjectivePoints();

	self:DoBrainSelection();
	self:DoWind();
	self:DoGenericActorEnumeration();
	self:DoSpecialAbilities();
	
	if self.CurrentFightPhase == self.FightPhase.SNEAKIN then
		self:PhaseSneakIn();
	elseif self.CurrentFightPhase == self.FightPhase.TOTALALERT then
		self:PhaseTotalAlert();
	elseif self.CurrentFightPhase == self.FightPhase.ESCAPE then
		self:PhaseEscape();
	end	
	-- self:SkipPhases();

	self:YSortObjectivePoints();
end
-----------------------------------------------------------------------------------------
-- Special abilities
-----------------------------------------------------------------------------------------
function Citadel:DoSpecialAbilities()
	if self.SpecialAbilitiesTimer:IsPastSimMS(self.SpecialAbilitiesInterval) then
		-- Gordon has infinite ronin grenades
		if self.Gordon ~= nil and MovableMan:IsActor(self.Gordon) then
			-- We check Gordon health becuase if he is dying and exploding we can 
			-- accidently spawn grenades somewhere in the air
			if self.Gordon.Health > 20 then
				for i = 1 , #self.RoninGrenades do
					if not self.Gordon:HasObject(self.RoninGrenades[i]) then
						self.Gordon:AddInventoryItem(CreateTDExplosive(self.RoninGrenades[i],"Ronin.rte"));
					end
				end
				
				if not self.Gordon:HasObject("C-4") then
					self.Gordon:AddInventoryItem(CreateTDExplosive("C-4" , "Citadel.rte"));
				end

				if not self.Gordon:HasObject("C-4 Detonator") then
					self.Gordon:AddInventoryItem(CreateHDFirearm("C-4 Detonator" , "Citadel.rte"));
				end
			end
		else
			self.Gordon = nil;
		end

		self.SpecialAbilitiesTimer:Reset();
	end
end
-----------------------------------------------------------------------------------------
-- Brain selection and gameover conditions check
-----------------------------------------------------------------------------------------
function Citadel:DoBrainSelection()
	if not (self.ActivityState == Activity.OVER) then
		-- Iterate through all human players
		for player = 0, self.PlayerCount - 1 do
			-- The current player's team
			local team = self:GetTeamOfPlayer(player);
	
			-- Make sure the game is not already ending
			-- Check if any player's brain is dead
			local brain = self:GetPlayerBrain(player);
			if not brain or not MovableMan:IsActor(brain) or not brain:HasObjectInGroup("Brains") then
				self:SetPlayerBrain(nil, player);
				-- Try to find a new unasigned brain this player can use instead, or if his old brain entered a craft
				local newBrain = MovableMan:GetUnassignedBrain(team);
				-- Found new brain actor, assign it and keep on truckin'
				if newBrain and self.braindead[player] == false then
					self:SetPlayerBrain(newBrain, player);
					self:SwitchToActor(newBrain, player, team);
				else
					FrameMan:SetScreenText("Commander died!", player, 333, -1, false);
					self.braindead[player] = true;
					
					-- Now see if all brains of self player's team are dead, and if so, end the game
					if not MovableMan:GetClosestBrainActor(team) then
						self.WinnerTeam = self:OtherTeam(team);
						ActivityMan:EndActivity();
					end
				end
			else
				-- Update the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
				self:SetObservationTarget(brain.Pos, player)
			end -- 
		end --for
	-- Game over, show the appropriate messages until a certain time
	elseif not self.GameOverTimer:IsPastSimMS(self.GameOverPeriod) then
		for player = 0, self.PlayerCount - 1 do
			local team = self:GetTeamOfPlayer(player);
			-- TODO: make more appropriate messages here for run out of funds endings
			if team == self.WinnerTeam then
				FrameMan:SetScreenText("Success!", player, 0, -1, false);
			else
				FrameMan:SetScreenText("Commander died!", player, 0, -1, false);
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- Make some wind
-----------------------------------------------------------------------------------------
function Citadel:DoWind()
	if self.WindTimer:IsPastSimMS(200) then
		for i = 0 , self.WindCount do
			-- self.Wind[math.random(#self.Wind)].Pos = self.WindZone:GetRandomPoint();
			self.Wind[i].Pos = self.WindZone:GetRandomPoint();
		end
		self.WindTimer:Reset();
	end
end

-----------------------------------------------------------------------------------------
-- Turn cloning vats on and off to prevent MOID limit hit
-----------------------------------------------------------------------------------------
function Citadel:CloneBreedingControl()
	local currentmoidlimit;
	
	currentmoidlimit = self.MOIDLimit;

	if MovableMan:GetMOIDCount() > currentmoidlimit then
		-- Disable cloning if we hit MOID limit
		self.CloningEnabled = false;
	else
		if self.CloningEnabled == false then
			if self.BaseOnAlert then
				-- Enable cloning if we below MOID limit and base on alert
				self.CloningEnabled = true;
				-- Reset startup timer to start vats asynchronous mode
				self.CloningVatsDesyncTimer:Reset();
			end
		else
			if not self.BaseOnAlert then
				self.CloningEnabled = false;
			end
		end
	end

	local vatsdead = 0;
	
	for i = 1 , #self.CloningVats do
		if  self.CloningVats[i] ~= nil and MovableMan:IsParticle(self.CloningVats[i]) then
			if self.CloningEnabled == false then
				self.CloningVats[i]:EnableEmission(false);
			else
				-- Every vat starts with 1.5 sec delay
				if self.CloningVatsDesyncTimer:IsPastSimMS(i * 1500) then
					if not self.CloningVats[i]:IsEmitting() then
						self.CloningVats[i]:EnableEmission(true);
						self.CloningVats[i].Frame = 1;
					end
				end
			end
		else
			self.CloningVats[i] = nil;
			vatsdead = vatsdead + 1;
		end
	end
	
	if vatsdead == 1 and not self.VatsWarningShown then
		for player = 0, self.PlayerCount - 1 do
			self:ResetMessageTimer(player);
			FrameMan:ClearScreenText(player);
			FrameMan:SetScreenText("DON'T DESTROY CLONING VATS!!!", player, 0, 5000, true);
		end
		self.VatsWarningShown = true;
	end
	
	-- If player destroyed more than one clone vat - gameover
	if vatsdead >= 2 then
		if not (self.ActivityState == Activity.OVER) then
			self.WinnerTeam = self.CPUTeam;
			ActivityMan:EndActivity();
		end
	end
end
-----------------------------------------------------------------------------------------
-- Set base on alert
-----------------------------------------------------------------------------------------
function Citadel:BaseAlertOn()
	if not self.BaseOnAlert then
		for i = 1, self.ScreenCount do
			self.Screens[i]:EnableEmission(false);
			MovableMan:RemoveParticle(self.Screens[i]);
			self.Screens[i] = nil;
			-- print (self.Screens[i]);

			self.Screens[i] = CreateAEmitter("Citadel Alert Screen");
			self.Screens[i].Pos = self.ScreensPos[i];
			self.Screens[i]:EnableEmission(true);
			MovableMan:AddParticle(self.Screens[i]);
		end
		self.BaseOnAlert = true;

		-- Reset all enemy troops destination points
		-- When base is on alert AI assigns GOTO modes for all actors
		for actor in MovableMan.Actors do
			if actor.Team == self.CPUTeam then
				actor.AIMode = Actor.AIMODE_SENTRY;
				actor:ClearAIWaypoints();
			end
		end		
	end
end
-----------------------------------------------------------------------------------------
-- Turn alert off
-----------------------------------------------------------------------------------------
function Citadel:BaseAlertOff()
	if self.BaseOnAlert then
		for i = 1, self.ScreenCount do
			self.Screens[i]:EnableEmission(false);
			MovableMan:RemoveParticle(self.Screens[i]);
			self.Screens[i] = nil;
			-- print (self.Screens[i]);

			self.Screens[i] = CreateAEmitter("Citadel Secured Screen");
			self.Screens[i].Pos = self.ScreensPos[i];
			self.Screens[i]:EnableEmission(true);
			MovableMan:AddParticle(self.Screens[i]);
		end
		self.BaseOnAlert = false;

		-- Reset all enemy troops destination points
		-- When base is not on alert AI assigns GOTO modes for all free actors
		for actor in MovableMan.Actors do
			if actor.Team == self.CPUTeam then
				actor.AIMode = Actor.AIMODE_SENTRY;
				actor:ClearAIWaypoints();
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- Do routines whuch require actor enumeration
-----------------------------------------------------------------------------------------
function Citadel:DoGenericActorEnumeration()
	for actor in MovableMan.Actors do
		if self.WindZone:IsInside(actor.Pos) then
			if actor.ClassName == "AHuman" then
				actor.Vel = actor.Vel + Vector(25 , 0);
			else
				actor.Vel = actor.Vel + Vector(0.03 , 0);
			end
		end

		-- Show marks above alerted actors
		for i = 1 , #self.CurrentAlertedActors do
			if self.CurrentAlertedActors[i][1] == actor.ID then
				self:AddObjectivePoint(self.AlertStrings[self.CurrentAlertedActors[i][2]], actor.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
				break;
			end
		end
		
		-- Give weapons through rearm stations. We need to check if the actor is friendly to CPU and if 
		-- enough time elapsed scince last rearming by selected station
		for i = 1 , #self.RearmSt do
			if self.RearmSt[i]:WithinBox(actor.Pos) then 
				if self.RearmStLastArm[i] + self.RearmInterval < self.RearmTimer.ElapsedSimTimeMS then
					if MovableMan:GetMOIDCount() < self.MOIDLimit and actor:IsInventoryEmpty() and actor.Team ~= self.PlayerTeam then
						if self.CurrentFightPhase ~= self.FightPhase.ESCAPE then
							actor:AddInventoryItem(CreateHDFirearm(self.LightWeapons[math.random(#self.LightWeapons)] , "Coalition.rte"));
						else
							actor:AddInventoryItem(CreateHDFirearm(self.ZombieWeapons[math.random(#self.ZombieWeapons)] , "Undead.rte"));
						end
						--Make the actor glow for a while.
						actor:FlashWhite(1000);
						--Create the teleportation effect for both teleporters in the set.
						local fxa = CreateAEmitter("Teleporter Effect A");
						fxa.Pos = actor.Pos;
						MovableMan:AddParticle(fxa);
						self.RearmStLastArm[i] = self.RearmTimer.ElapsedSimTimeMS;
						break;
					end --if
				end -- if
			end -- if
		end -- for
	end -- for
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function Citadel:AddAlertedActor(actor , target)
	local toinsertpos = #self.CurrentAlertedActors + 1;
	local oldalertstate = 1;
	
	for i = 1 , #self.CurrentAlertedActors do
		if self.CurrentAlertedActors[i][1] == actor.ID then
			toinsertpos = i;
			break;
		end
	end
	
	for i = 1 , #self.OldAlertedActors do
		if self.OldAlertedActors[i][1] == actor.ID then
			oldalertstate = self.OldAlertedActors[i][2];
			break;
		end
	end
	
	if oldalertstate < #self.AlertStrings then
		if self.BaseOnAlert then
			oldalertstate = #self.AlertStrings;
		else
			oldalertstate = oldalertstate + 1;
		end
	end
	
	actor.AIMode = Actor.AIMODE_GOTO;
	actor:ClearAIWaypoints();
	actor:AddAISceneWaypoint(target.Pos);
	
	self.CurrentAlertedActors[toinsertpos] = {actor.ID , oldalertstate , target.Pos};
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function Citadel:IsEven(number)
	if math.floor(number / 8) % 2 == 0 then
		return true;
	else
		return false;
	end
end
-----------------------------------------------------------------------------------------
-- Alert triggering and detection logic
-----------------------------------------------------------------------------------------
function Citadel:AlertLogic()
	if self.AlertCheckTimer:IsPastSimMS(self.AlertCheckInterval) then
		local tomakealert = false;
		--local spottedstate = self.Spotted;

		self.Spotted = false;
	
		-- Save current alerted list as old to increment values from it later
		self.OldAlertedActors = self.CurrentAlertedActors;
		-- Clear current alerted list as it will be refilled in loop
		self.CurrentAlertedActors = {};
		
		--[[-- Old piece of code reserved for historical and debug purposes
		-- Enumerate all enemy actors to check if they spotted an enemy
		for eactor in MovableMan.Actors do
			if eactor.Team == self.CPUTeam and eactor.ClassName ~= "ADoor" then
				-- For every enemy actor enumerate friendly actors and fire MORays at them to check
				-- if they are spotted
				for factor in MovableMan.Actors do
					if factor.Team == self.PlayerTeam and factor.ClassName ~= "ADoor" then
						local eactorpos = Vector(eactor.Pos.X , eactor.Pos.Y - 15); -- Try to fire MO Rays from head
						local vectortoactor = factor.Pos - eactorpos;
						if vectortoactor.Magnitude < self.AlertDistance then
							local startpos = eactorpos + Vector(vectortoactor.X / vectortoactor.Magnitude * 15 , vectortoactor.Y / vectortoactor.Magnitude * 15);
							local i = SceneMan:CastMORay(startpos , vectortoactor , 0 , 0 , false , 4);
							local thingie = MovableMan:GetMOFromID(i);

							if thingie ~= nil and thingie.RootID == factor.ID then
								
								-- factor:FlashWhite(25);
								-- eactor:FlashWhite(25);
								
								self:AddAlertedActor(eactor , factor);
								self.Spotted = true;
							end -- if
						end -- if
					end -- if
				end -- for
			end -- if
		end -- for]]--

		-- Enumerate all enemy actors to check if they spotted an enemy
		for eactor in MovableMan.Actors do
			if eactor.Team == self.CPUTeam and eactor.ClassName ~= "ADoor" then
				-- For every enemy actor enumerate friendly actors and fire MORays at them to check
				-- if they are spotted
				for i = 1,#self.Ronins do
					if MovableMan:IsActor(self.Ronins[i]) then
						local eactorpos = Vector(eactor.Pos.X , eactor.Pos.Y - 15); -- Try to fire MO Rays from head
						local vectortoactor = self.Ronins[i].Pos - eactorpos;
						if vectortoactor.Magnitude < self.AlertDistance then
							local startpos = eactorpos + Vector(vectortoactor.X / vectortoactor.Magnitude * 15 , vectortoactor.Y / vectortoactor.Magnitude * 15);
							local j = SceneMan:CastMORay(startpos , vectortoactor , 0 , 0 , false , 4);
							local thingie = MovableMan:GetMOFromID(j);

							if thingie ~= nil and thingie.RootID == self.Ronins[i].ID then
								
								-- self.Ronins[i]:FlashWhite(25);
								-- eactor:FlashWhite(25);
								
								self:AddAlertedActor(eactor , self.Ronins[i]);
								self.Spotted = true;
							end -- if
						end -- if
					else
						self.Ronins[i] = nil;
					end -- if
				end -- for
			end -- if
		end -- for
		
		--[[if spottedstate ~= self.Spotted then
			print ("Alert Stop Timer Reset");
			self.AlertStopTimer:Reset();
		end]]--
		
		-- Check if we have alerted enough an actor to launch a base alert
		for i = 1, #self.CurrentAlertedActors do
			if self.CurrentAlertedActors[i][2] == #self.AlertStrings then
				tomakealert = true;
				self.AlertSource = self.CurrentAlertedActors[i][3];
				break;
			end
		end

		-- Reset alert stop countdown if wea are still spotted
		if self.Spotted then
			if tomakealert then
				self:BaseAlertOn();
				self.AlertStopTimer:Reset();
			end
		else
			if self.AlertStopTimer:IsPastSimMS(self.AlertStopInterval) then
				self:BaseAlertOff();
			end
		end
		
		-- Resend all enemy troops to check alert source if base is on alert
		if self.BaseOnAlert then
			for actor in MovableMan.Actors do
				-- Enum only mod 3 actors during one phase to
				-- prevent heavy lagging. I use mod 3 because all actor.ID seems to be odd
				if actor.Team == self.CPUTeam  and actor.AIMode ~= Actor.AIMODE_GOTO then
					if self:IsEven(actor.ID) == self.EnumEven and math.random(100) > 5  then
						actor.AIMode = Actor.AIMODE_GOTO;
						actor:ClearAIWaypoints();
						actor:AddAISceneWaypoint(self.AlertSource);
					end
				end -- if
			end -- for
		else
			-- Resend all enemy troops to closes patrol areas if alert is off
			-- Scan all patrol zones. If we have AIMODE_SENTRY troops there,
			-- GOTO them to the most far patrol point
			for actor in MovableMan.Actors do
				if self:IsEven(actor.ID) == self.EnumEven then
					if actor.Team == self.CPUTeam and actor.AIMode ~= Actor.AIMODE_GOTO then
						for i = 1 , #self.PatrolZones do
							if self.PatrolZones[i]:IsInside(actor.Pos) then
								-- Calc distances to available patrol waypoint and send actor to the most far
								local dist1 = math.sqrt((actor.Pos.X - self.PatrolWaypoints[i][1].X) ^ 2 + (actor.Pos.Y - self.PatrolWaypoints[i][1].Y) ^ 2);
								local dist2 = math.sqrt((actor.Pos.X - self.PatrolWaypoints[i][2].X) ^ 2 + (actor.Pos.Y - self.PatrolWaypoints[i][2].Y) ^ 2);
								
								-- actor:FlashWhite(50);
								actor.AIMode = Actor.AIMODE_GOTO;
								actor:ClearAIWaypoints();
								actor:DrawWaypoints(true);
								if dist1 < dist2 then
									actor:AddAISceneWaypoint(self.PatrolWaypoints[i][2]);
								else
									actor:AddAISceneWaypoint(self.PatrolWaypoints[i][1]);
								end --if
								break;
							end -- if
						end -- for
					end -- if 
				end
			end -- for
		end -- if else
		
		self.AlertCheckTimer:Reset();
		self.EnumEven = not self.EnumEven;
	end
end -- func
-----------------------------------------------------------------------------------------
-- Operate enemy units druing total alert phase
-----------------------------------------------------------------------------------------
function Citadel:TotalAlertLogic()
	-- On total alert we send all clones to attack control center. Clones can't use teleporters so wee need to
	-- first send them to the teleport, then check if they are in control center and then set them in brain hunt mode.
	-- To decrease heavy lag caused by AI we send units below 2000 pixels to storm the control room, units in control
	-- room to brainhunt and all the others to standard patroling and zombie hunt
	if self.AlertCheckTimer:IsPastSimMS(500) then
		-- Resend all enemy troops to check alert source if base is on alert
		if self.BaseOnAlert then
			for actor in MovableMan.Actors do
				-- Enum only even or odd actors during one phase to
				-- prevent heavy lagging.
				if actor.Team == self.CPUTeam then 
					if self:IsEven(actor.ID) == self.EnumEven and math.random(100) > 4 then
						if actor.Pos.Y < 2000 then
							if actor.AIMode ~= Actor.AIMODE_GOTO then
								for i = 1 , #self.PatrolZones do
									if self.PatrolZones[i]:IsInside(actor.Pos) then
										-- Calc distances to available patrol waypoint and send actor to the most far
										local dist1 = math.sqrt((actor.Pos.X - self.PatrolWaypoints[i][1].X) ^ 2 + (actor.Pos.Y - self.PatrolWaypoints[i][1].Y) ^ 2);
										local dist2 = math.sqrt((actor.Pos.X - self.PatrolWaypoints[i][2].X) ^ 2 + (actor.Pos.Y - self.PatrolWaypoints[i][2].Y) ^ 2);
										
										-- actor:FlashWhite(50);
										actor.AIMode = Actor.AIMODE_GOTO;
										actor:ClearAIWaypoints();
										actor:DrawWaypoints(true);
										if dist1 < dist2 then
											actor:AddAISceneWaypoint(self.PatrolWaypoints[i][2]);
										else
											actor:AddAISceneWaypoint(self.PatrolWaypoints[i][1]);
										end --if
										break;
									end -- if
								end -- for
							end -- if 
						elseif actor.Pos.Y < 5000 then
							if actor.AIMode ~= Actor.AIMODE_GOTO then
								actor.AIMode = Actor.AIMODE_GOTO;
								actor:ClearAIWaypoints();
								actor:AddAISceneWaypoint(Vector(492, 2832)); -- To teleporter A
							end -- if
						else
							if actor.AIMode ~= Actor.AIMODE_BRAINHUNT then
								if self:IsEven(actor.ID) == self.EnumEven then
									actor.AIMode = Actor.AIMODE_BRAINHUNT;
								end -- if
							end -- if
						end -- if else
					end -- if
				end -- if
			end -- for
		end -- if else
		
		self.AlertCheckTimer:Reset();
		self.EnumEven = not self.EnumEven;
	end -- if
end -- func
-----------------------------------------------------------------------------------------
-- Spawn exterminator dropship. Returns true if spawn is successfull, false otherwise
-----------------------------------------------------------------------------------------
function Citadel:SpawnDropship()
	if MovableMan:GetMOIDCount() < self.UltimateMOIDLimit then
		local ship = CreateACDropShip("Drop Ship MK1","Base.rte");
		local actor = nil;
		
		for i = 1, 2 do
			actor = CreateAHuman("Soldier Light" , "Coalition.rte");
			actor:AddInventoryItem(CreateHDFirearm("Flamer" , "Coalition.rte"));
			actor:AddInventoryItem(CreateHDFirearm("Shotgun" , "Coalition.rte"));
			actor:AddInventoryItem(CreateTDExplosive("Incendiary Grenade" , "Coalition.rte"));
			actor.Team = self.CPUTeam;
			actor.AIMode = Actor.AIMODE_GOTO;
			actor:AddAISceneWaypoint(Vector(492, 1800));

			ship:AddInventoryItem(actor);
		end
		-- Select LZ
		ship.Pos = Vector(440,0);
		ship.Team = self.CPUTeam;
		ship:SetControllerMode(Controller.CIM_AI, -1);

		MovableMan:AddActor(ship);
		return true;
	end
	return false;
end

-----------------------------------------------------------------------------------------
-- Phase "Sneak in"
-----------------------------------------------------------------------------------------
function Citadel:PhaseSneakIn()
	self:AlertLogic();
	self:CloneBreedingControl();
	
	-- Show character marks
	if not self.GenericTimer:IsPastSimMS(15000) then
		--[[if self.Mia ~= nil and MovableMan:IsActor(self.Mia) then
			self:AddObjectivePoint("Mia - Stealth", self.Mia.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end]]--

		if self.Dimitri ~= nil and MovableMan:IsActor(self.Dimitri) then
			self:AddObjectivePoint("Dimitry - Sniper", self.Dimitri.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end

		if self.Gordon ~= nil and MovableMan:IsActor(self.Gordon) then
			self:AddObjectivePoint("Gordon - Explosives", self.Gordon.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end

		for player = 0, self.PlayerCount - 1 do
			if MovableMan:IsActor(self.AssignedBrains[player]) then
				self:AddObjectivePoint("Dafred - Commander - Best", self.AssignedBrains[player].AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
			end
		end
	end

	self:AddObjectivePoint("INSTALL", Vector( 393 , 5256), self.PlayerTeam, GameActivity.ARROWDOWN);
	self:AddObjectivePoint("VIRUS", Vector( 593 , 5256), self.PlayerTeam, GameActivity.ARROWDOWN);
	
	-- Check current objectives
	for player = 0, self.PlayerCount - 1 do
		if MovableMan:IsActor(self.AssignedBrains[player]) then
			if self.TerminalZone:IsInside(self.AssignedBrains[player].Pos) then
				if self.AssignedBrains[player]:HasObject("Virus Chip") then
					self:AdvanceToTotalAlert();
				end
			end
		end
	end -- for
end
-----------------------------------------------------------------------------------------
-- "Sneak in" -> "Total Alert"
-----------------------------------------------------------------------------------------
function Citadel:AdvanceToTotalAlert()
	print ("Sneak in -> Total Alert");
    self.CurrentFightPhase = self.FightPhase.TOTALALERT;
	self:BaseAlertOn();
	self.GenericTimer:Reset();
end
-----------------------------------------------------------------------------------------
-- Phase "Total Alert"
-----------------------------------------------------------------------------------------
function Citadel:PhaseTotalAlert()
	self:TotalAlertLogic();
	self:CloneBreedingControl();
	
	-- Check current objectives
	local isinside = false;
	
	-- Show upload completion mark
	for player = 0, self.PlayerCount - 1 do
		if MovableMan:IsActor(self.AssignedBrains[player]) then
			if self.TerminalZone:IsInside(self.AssignedBrains[player].Pos) then
				if self.AssignedBrains[player]:HasObject("Virus Chip") then
					self:AddObjectivePoint(string.format("Uploading: %d%%", self.ChunksComplete / self.TotalChunks * 100), self.AssignedBrains[player].AboveHUDPos, self.PlayerTeam, GameActivity.ARROWUP);
					isinside = true;
				end
			end
		end
	end -- for
	
	-- Check upload status
	if not isinside then
		self:AddObjectivePoint("INSTALL", Vector( 393 , 5256), self.PlayerTeam, GameActivity.ARROWDOWN);
		self:AddObjectivePoint("VIRUS", Vector( 593 , 5256), self.PlayerTeam, GameActivity.ARROWDOWN);
		self.GenericTimer:Reset();
	else
		if self.GenericTimer:IsPastSimMS(self.ChunkInterval) then
			self.ChunksComplete = self.ChunksComplete + 1;
			if self.ChunksComplete >= self.TotalChunks then
				self:AdvanceToEscape();
			end
			self.GenericTimer:Reset();
		end
	end
end
-----------------------------------------------------------------------------------------
-- "Total Alert" -> "Escape"
-----------------------------------------------------------------------------------------
function Citadel:AdvanceToEscape()
	print ("Total Alert -> Escape");
    self.CurrentFightPhase = self.FightPhase.ESCAPE;
	self.GenericTimer:Reset();
	
   	-- "Reprogram" cloning vats
	for i = 1 , 5 do
		if  self.CloningVats[i] ~= nil and MovableMan:IsParticle(self.CloningVats[i]) then
			self.CloningVats[i]:EnableEmission(false);
			MovableMan:RemoveParticle(self.CloningVats[i]);
			self.CloningVats[i] = nil;
			self.CloningVats[i] = CreateAEmitter("Zombie Vat" , "Citadel.rte");
			self.CloningVats[i].Pos = self.CloningVatsCoords[i];
			self.CloningVats[i].Team = self.RogueTeam;
			self.CloningVats[i]:EnableEmission(true);
			MovableMan:AddParticle(self.CloningVats[i]);
		else
			self.CloningVats[i] = nil;
		end
	end
	
	-- Make static screens
	for i = 1, self.ScreenCount do
		self.Screens[i]:EnableEmission(false);
		MovableMan:RemoveParticle(self.Screens[i]);
		self.Screens[i] = nil;

		self.Screens[i] = CreateAEmitter("Citadel Small Static Screen");
		self.Screens[i].Pos = self.ScreensPos[i];
		self.Screens[i]:EnableEmission(true);
		MovableMan:AddParticle(self.Screens[i]);
	end

	self.BigScreenA:EnableEmission(false);
	MovableMan:RemoveParticle(self.BigScreenA);
	self.BigScreenA = nil;
	self.BigScreenA = CreateAEmitter("Citadel Big Static Screen");
	self.BigScreenA.Pos = Vector(384,5204);
	self.BigScreenA:EnableEmission(true);
	MovableMan:AddParticle(self.BigScreenA);

	self.BigScreenB:EnableEmission(false);
	MovableMan:RemoveParticle(self.BigScreenB);
	self.BigScreenB = nil;
	self.BigScreenB = CreateAEmitter("Citadel Big Static Screen");
	self.BigScreenB.Pos = Vector(600,5204);
	self.BigScreenB:EnableEmission(true);
	MovableMan:AddParticle(self.BigScreenB);
end
-----------------------------------------------------------------------------------------
-- Phase "Escape"
-----------------------------------------------------------------------------------------
function Citadel:PhaseEscape()
	self:TotalAlertLogic();
	self:CloneBreedingControl();

	-- Spawn coalition dropship
	if 	self.DropshipSpawnTimer:IsPastSimMS(self.DropshipSpawnInterval) then
		if self:SpawnDropship() then
			self.DropshipSpawnTimer:Reset();
		end
	end
	
	local ontop = false;

	for player = 0, self.PlayerCount - 1 do
		if MovableMan:IsActor(self.AssignedBrains[player]) then
			if self.AssignedBrains[player].Pos.Y < 600 then
				ontop = true;
			end
		end
	end -- for

	if ontop then
		if not MovableMan:IsActor(self.EvacDropship) then
			print ("New Dropship");

			self.EvacDropship = CreateACDropShip("Drop Ship MK1" , "Base.rte");
			self.EvacDropship.Pos = Vector(600 , -10);
			self.EvacDropship.Team = self.PlayerTeam;
			self.EvacDropship:SetControllerMode(Controller.CIM_AI, -1);
			
			MovableMan:AddActor(self.EvacDropship);
		else
			self:AddObjectivePoint("EVACUATE", self.EvacDropship.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWUP);
		end --if
	else
		self:AddObjectivePoint("EVACUATE", Vector(492 , 10), self.PlayerTeam, GameActivity.ARROWUP);
	end
end
-----------------------------------------------------------------------------------------
-- Enter orbit, check winning conditions
-----------------------------------------------------------------------------------------
function Citadel:CraftEnteredOrbit()
	--If a craft leaves with the brain robot...
	if not (self.ActivityState == Activity.OVER) then
		if self.OrbitedCraft:HasObject("Dafred Brain Citadel") then
			-- Team 1 wins!
			self.WinnerTeam = self.PlayerTeam;
			ActivityMan:EndActivity();
			self.EvacuateComplete = true;
			-- Tell the script to stop running for brains as the game has ended.
			for player = 0, self.PlayerCount - 1 do
				self.braindead[player] = true;
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- That's all folks!
-----------------------------------------------------------------------------------------






















